var Url    = require('url'),
EventEmitter = require('events').EventEmitter,
netWorker = require('./net_worker'),
http = require('http'),
netLoader = netWorker.load,          
compress = require('compress'),
smart = require('sk/core/smart').smart,
SmartCacher = smart.Cacher,
utils = require('sk/node/utils');


 

exports.Request = URLRequest;
exports.loadJSON = loadJSON;  
exports.findLocation = findLocation;
exports.getContentLength = getContentLength;
exports.loadRequest = loadRequest;

//kills a request based in the URI given
exports.killRequest = netWorker.killRequest;     

function URLRequest(url, ttl, cacher, encoding)
{
	
	this.url 		 = (url || '').replace(' ','%20');
	this.host		 = 'localhost';
	this.pathdir	 = '/';//path to current dir
	this.method 	 = 'GET';
	this.encoding	 = encoding;
	this.data    	 = {};
	this.headers     = {};
	//this.cacher      = cacher || 'db';
	this.ttl		 = ttl != undefined ? ttl : -1;
	this.encodedData = '';
	
	//this is here because some fucking idiots developed a script that does a HUGE redirect AHEM: http://www.sears.com/shc/s/dap_10153_12605_DAP_wall+decorator?storeId=10153&adCell=W6&vName=wall+decorator&catalogInd=DAP&catalogId=12605&i_cntr=1299473458901&i_cntr=1299474573644
	this.maxRedirects = 5;
	

	var parsed = false;
	var self = this;
	

	this.getData = function()
	{
		var buffer = [];

		for(var i in self.data)
		{
			buffer.push(i+"="+self.data[i]);
		}
		return buffer.join('&');
	}


	this.build = function()
	{

		if(self.url.indexOf('://') == -1)
		{
			self.url = 'http://'+self.url;
		}
		else
		{
			//if there is http://http://, it will definitely break the app :(
			self.url = self.url.replace(/(\w+:\/\/)+/,'$1');
		}
		
		//check if the url is also valid
		

		
		try
		{
			var info = Url.parse(self.url,true);	
		}catch(e)
		{
			console.error(e)
		}     
		
		self.method = self.method.toUpperCase();
		
		self.host     = info.host;
		self.hostname = info.hostname || info.host;
		self.port     = info.port     || (info.protocol == 'https:' ? 443 : 80);
		self.search   = info.search   || '';
		self.pathname = info.pathname || '/';
		self.protocol = info.protocol;
		
		var path = self.pathname.match(/(\w+\/)+/g);
		
		self.pathdir  = path ? '/'+path[0] : '/';

		self.headers['host'] = self.hostname;
		var data = self.getData();
		
		
		if(self.method == 'POST' || self.method == 'PUT')
		{
			self.headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=UTF-8'; 
			self.headers['Content-Length'] = data.length;
		}                         
		else  
		if(data.length > 0)
		{
			self.search = self.search != '' ? self.search+'&'+data : self.search+'?'+data; 
		}
		
		self.builtUrl = self.protocol+'//'+self.host+self.pathname+self.search;
		self.encodedData = data;

		parsed = true;
	} 
	
	
	this.setCredentials = function(user,pass)
	{
		self.headers.authorization = 'Basic '+utils.base64.encode(user+':'+pass);
	}
	
	
	this.build();
}             



var loads = {};


function _initLoad(request,callbacks)
{
	if(callbacks.init) callbacks.init();  


	callbacks.crash = function()
	{
		console.warning(('loader broke, reloading: '+request.url).red);
		initLoad();
	}
	
	
	function initLoad()
	{
		var ret = netLoader(request,callbacks);
		if(callbacks.start) callbacks.start(ret);
		callbacks.request = ret;
		return ret;
	}
	
	return initLoad();
}

function setRedirectUrl(request,url)
{
	console.verbose('redirect from:'+request.url+' to:'+url);   

	//redirects can also be /ffda/fdsfa
	request.url = (url || '').indexOf('://') > -1 ? url : request.protocol+'//'+request.hostname+url;
}

//loads data from the database
/*function _loadCached(request, callbacks)
{
	request.build();
	
	Cache.open(request.cacher, request.builtUrl + (request.responseOnly ? 'redirect' : '') + '_request', request.ttl, function (cacher)
	{
		_initLoad(request,{
			init:callbacks.init
			,start:callbacks.start
			,data:function(chunk)
			{
				cacher.record('data',chunk);
			}
			,end:function(chunk)
			{
				cacher.end(chunk);
			}
			,redirect:function(url)
			{
				//ALWAYS cache redirected urls
				cacher.ttl = 1000*60*60*24*30;//30 days
				//abort the request so we don't load the data. this doesn't work for some odd reason..

				cacher.record('redirect',url);
				cacher.delink();
			}
			,response:function(response)
			{
				cacher.record('response',response);    
				
				//OLD - replace later
				cacher.record('headers',response.headers);
				
				if(!(response.statusCode > 300 && response.statusCode < 309) && callbacks.responseOnly)
				{
					this.request.abort();
					cacher.end('');
				}
			}
			,fail:function()
			{
				//notify the users
				cacher.end('');
				
				//THE DESTROY IT!
				cacher.dispose();
			}
			,crash:function()
			{
				console.warning(('loader broke, reloading: '+request.url).red);
				initLoad();
			}
		}) 
		
		
	},
	function(cacher)
	{
		request.build();
		
		function onRedirect(url)
		{
			                
			setRedirectUrl(request,url);
			
			if(--request.maxRedirects)
			{
			
				//reload the request since we've been redirected.
				loadRequest(request,callbacks);
			}
			else
			{
				console.warning(url+" threw the app into a stupid long redirect, and the request was stopped. ");
				callbacks.end();
			}
			
		}
		
		
		//NOTE: on END, the cacher automatically removes events listened to.
		['data','end','response'].forEach(function(ev)
		{
			if(callbacks[ev]) cacher.on(ev,callbacks[ev]);
		})
		
		cacher.on('redirect',onRedirect);
	});
}*/





function _loadRegular(request,callbacks)
{
	
	callbacks.redirect = function(url)
	{
		setRedirectUrl(request,url);
		_initLoad(request,callbacks);
	};

	var oldResponse = callbacks.response,
	oldFail = callbacks.fail;

	callbacks.response = function(response)
	{
		if(oldResponse) oldResponse(response);
		
		if(!(response.statusCode > 300 && response.statusCode < 309) && callbacks.responseOnly)
		{
			callbacks.request.abort();
			callbacks.end();
		}
	};

	callbacks.fail = function()
	{
		try
		{
			if(oldFail) oldFail();
		}catch(e)
		{
			console.error(e.stack)
		}
	};

	['data','crash','redirect','end'].forEach(function(fill)
	{
		if(!callbacks[fill]) callbacks[fill] = function(){}
	})


	return _initLoad(request,callbacks);

}

var gunzip = new compress.Gunzip();


//better alternative than create a new URLLoader - takes up too much memory.
function loadRequest(urlOrRequest, callbacks)
{
	var request = (typeof urlOrRequest == 'string') ? new URLRequest(urlOrRequest) : urlOrRequest; 
	
	if(typeof callbacks == 'function')
	{
		var callback = callbacks,
			buffers = [],
			compressed = false;			                              
			
			//causes mem corruption
			delete request.headers['accept-encoding']; 
			
			//gzip compression, or utf8 >.>
			// request.headers['accept-encoding'] = 'gzip';
			// request.encoding = 'binary'; 
			
			callbacks = {
				response:function(response)
				{
					compressed = response.headers['content-encoding'] == 'gzip';
				}
				,data:function(chunk)
				{
					buffers.push(chunk);
				}
				,end:function()
				{
					if(compressed)
					{
						gunzip.init();
						callback(gunzip.inflate(buffers.join(''),'binary'));
						gunzip.end();
					}
					else
					{
						callback(buffers.join(''));
					}
				}
				,fail:function()
				{
					callback(null);
				}
			}
	}
	
	if(!request.encoding) request.encoding = callbacks.encoding;
	 
	var oldInit = callbacks.init,
		oldStart = callbacks.start;       
		
		
	if(!callbacks)
	{
		throw new Exception('Cannot load a request without a callback')
	}
	
	callbacks.init = function()
	{
		if(oldInit) oldInit();
		
		request.build();
		request._data = request.getData();     
		
		
		//this MIGHT cause a memory leak, but it's faster.
		request.headers['User-Agent'] = 'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_6_6; en-us) AppleWebKit/533.19.4 (KHTML, like Gecko) Version/5.0.3 Safari/533.19.4';
		request.headers['Accept'] = '*/*';
		request.headers['Connection'] = 'keep-alive';
		
		////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		//this is SUPPOSED to fix the process.nextTick error
		//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		//however - some servers don't like this and return a 411 error... such as instagram
		// request.headers['Transfer-Encoding'] = 'chunked';

		if(!request.headers['Content-Type']) request.headers['Content-Type'] = 'application/json';
	};
	
	callbacks.start = function(request)
	{
		callbacks.request = request;
		
		if(oldStart) oldStart();
	}
	
	//if we're caching data, then we want to use the load cacher. This isn't always ideal >.>
	var loadFunction = _loadRegular;//(request.ttl > -1 ? _loadCached : _loadRegular);
	
	
	
	
	return loadFunction(request,callbacks);
}      

var cachedRedirects = {};    
  
       
//
smart.interval(function()
{                                          
	var now = new Date().getTime();
	
	for(var i in cachedRedirects)
	{
		var urlInfo = cachedRedirects[i];
		if(urlInfo.deleteAt < now)
		{                 
			delete cachedRedirects[i];
		}
	}
},10000);      
                                            
//1000000 ~ 15 MB
var redirectCacher = new SmartCacher(1000000),
	redirectWhiteList = new SmartCacher(1000000,'urlWhiteList',true)//N users * N concurrent feeds * N urls per feed

//ugly
function findLocation(url,ttl,callback)
{       
	
	if(!callback)
	{
		callback = ttl;
		ttl = undefined;//3600*24*7;//undefined;
	}
	           
	var urlParts = Url.parse(url),
	    whiteListableUrlPart = (urlParts.hostname+urlParts.pathname).split('/'); 
		whiteListableUrlPart.pop();
		whiteListableUrlPart = whiteListableUrlPart.slice(0,3).join('/');
	
	
	var cache = redirectCacher.get(url),
		whiteListedRedirect = redirectWhiteList.get(whiteListableUrlPart);
	
	if(cache) 
	{  
		console.success('Using cached redirect from memory: '+cache); 
		redirectCacher.reset(url); //reset time to live so we keep it longer
		return callback(cache)
	} 
	else
	if(whiteListedRedirect && false)
	{
		console.success('using white listed url for: '+url);
		redirectWhiteList.reset(whiteListableUrlPart);
		return callback(url);
	}
	
	
	var request = new URLRequest(url,ttl,'db');
		request.headers['Accept-Encoding'] = 'gzip, deflate';
		request.headers['Accept-Language'] = 'es-es';
	
	return loadRequest(request,
		{
		responseOnly:true
		,fail:function()
		{
			callback(null);
		}
		,end:function(response)
		{              
			//no change? whitelist the url         
			if(url == request.url)
			{
				redirectWhiteList.set(whiteListableUrlPart,1,60000);
			}
			redirectCacher.set(url,request.url,60000);//cache the redirect
			callback(request.url) 
		}
	})
}
       

function getContentLength(url,callback)
{
	loadRequest(new URLRequest(url),{
		responseOnly:true
		,response:function(response)
		{
			if(response.statusCode > 300 && response.statusCode < 308) return;        
		
			callback(response.headers['content-length'] || 0,response.headers['content-type']);
		}
	});
}


function loadJSON(url,onEndCallback,params)
{
	loadRequest(url,function(buffer)
	{
		try
		{
			onEndCallback(JSON.parse(buffer));
		}
		catch(e)
		{                        
			console.warning('unable to parse %s JSON because response is not JSON.', url);
			onEndCallback(null);
		}
	});
}

           
exports.stats = {
	getUrlScore:function()
	{
		
	}
}

