var base64_decode= require('base64').decode;
var Buffer = require('buffer').Buffer; 
var Structr = require('structr');

var realm = "Authorization";


/* how-to: 
 
 var auth  = new BasicAuth(login);
 auth.authenticate(
 
 */
 
var BasisAuth = Structr({
	__construct:function(loginCallback)
	{
		this.loginCallback = loginCallback;   
	},
	hasBasicAuthentication: function(request)
	{
		return !!request.client.headers['authorization'];
	},  
	parseBasicAuth: function(auth)
	{
		var authCredits = base64_decode(auth.substr(6)).split(':');//skip Basic 
			
		var user = authCredits[0];
		var pass = authCredits[1];
		
		return {user: user, pass: pass};
	},
	authenticate:function(request,callback)
	{         
		function login()
		{

			request.statusCode = 401;
			request.headers['WWW-Authenticate'] = 'Basic realm="'+realm+'"';//`, qop="auth" ,nonce="'+(new Date().getTime())+'",opaque="'+opaque+'"'

			request.end("Not authorized.");  
		}


		var authCredits = request.client.headers['authorization']

		//if the client has sent authorization headers, then continue logging them in.
		if(authCredits) //look for something like: Basic ZmRhZjpmc2Rmc2Rmc2ZzZA==
		{
			//1. strip away Basic
			//2. decode the b64 encoded string
			//3. split apart username:password
			var authCredits = this.parseBasicAuth(authCredits);
			
			var user = authCredits.user;
			var pass = authCredits.pass;

			this.loginCallback(user,pass,function(err,user)
			{	
				//if we've failed, 
				if(!user) return login();

				//pass on the loggin in user
				request.user = user;

				callback(user);

			});

			//stop from logging in
			return;
		}

		login();
	}
});


exports.BasicAuth = BasisAuth;