function sortImageMetadata(a,b)
{
	return a.score-b.score;
}

exports.standardizeFromHtml = function(item,metadata)
{                                         
	var text = item.text || '',
	    imageRegex = /<img.*?src=['"](.*?)['"].*?>/i,
		images = [],
		anchors = [],
		anchorResult,
		imageResult,
		results;   

                 
	//remove read more
	text = text.replace(/<a.*?>.*?read\smore.*?<\/a>/g,' ');                                  
	
		//let's match up all links. Make sure we only grab links that are wrapped around text, and not images
	while((results = text.match(/<a.*?href=['"](.*?)['"].*?>(.*?)<\/a>/)))
	{           
		var anchorResult = results[0];
		                                                  
		                    
		//if an image IS present, then check if it's an image we want, or skip it. 
		if(anchorResult.indexOf('<img') > -1)
		{                                         
			if(results[1] == item.link && (imageResult = anchorResult.match(imageRegex)))
			{                        
				imageResult.score = 100;
				images.push(imageResult);
			}       
				   
				
			text = text.replace(anchorResult,'');     
			continue;
		} 
			
		
		anchors.push(results);        
        text = text.replace(anchorResult,results[2]);  
	} 
	         
	//look for ALL images. we'll use these to pretty-up the document
	while((results = text.match(imageRegex)))
	{             
		var imageResult = results[0];
		images.push(results);        
        text = text.replace(imageResult,'');  
	}        
	
	// console.log(text)      
	 
	 
	//let's clean up the text so there isn't any trashy html tags. retain the important ones such as p,l,ul,li,br but remove
	//longer ones such as div,style,script,etc.
	item.text = text.replace(/<(\w{3,}).*?(\/>|>[\s\S]*?<\/(\1)>)/ig,'').    
	
				//we want just plain tags. Strip out any styles, or shit that could muck up whatever app's using this content 
	      		replace(/<(\w+).*>(.*?)<\/(\1)>/ig,'<$1>$2</$1>').                                                           
	
				//condense the linebreaks
	            replace(/\s+/ig,' ').
	
				//non-ascii characters
				replace(/[^\x20-\x7E]/,'');
	    
	var imageMetadata = [];

	var n = images.length;
	for(var i = n; i--;)
	{
		var image = images[i],
		    result = image[0],
		    link  = image[1],
		widthMatch = result.match(/width=['"](.*?)['"]/),
		heightMatch = result.match(/height=['"](.*?)['"]/);
		
		var width  = widthMatch  ? Number(widthMatch[1])  : 0,
			height = heightMatch ? Number(heightMatch[1]) : 0;   
	                                      
		//only use good photos.
        if((width && width < 100) || (height && height < 100) || link.indexOf('gif') > -1) continue;       
                                     
		//score based on position of image
		var score = width+height+n-i;            
		
		//the happens if we find an image linking to the article	
		if(image.score) score += image.score;
		
		var image = {
			type:'image'
			,regular:{
				link:link
				,score:score
			}
		}
		if(width)
		{
			image.regular.width = width;
		}
		if(width)
		{
			image.regular.height = height;
		}
		
		imageMetadata.push(image);
	}                
	
	imageMetadata.sort(sortImageMetadata);   
	
	item.metadata = item.metadata.concat(imageMetadata);                                                      
	
	for(i = anchors.length; i--;)
	{                                   
		var anchor = anchors[i];
		   
		if(!anchor[2]) continue;                      
		
		item.metadata.push({type:'url',link:anchor[1],match:anchor[2]});
	}
	// console.log(item.text)        
}
